Package org.opencv.features

## Class SimpleBlobDetector

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.features.Feature2D
    - - org.opencv.features.SimpleBlobDetector

-     public class SimpleBlobDetector
      extends Feature2D

  Class for extracting blobs from an image. : The class implements a simple algorithm for extracting blobs from an image: 1. Convert the source image to binary images by applying thresholding with several thresholds from minThreshold (inclusive) to maxThreshold (exclusive) with distance thresholdStep between neighboring thresholds. 2. Extract connected components from every binary image by findContours and calculate their centers. 3. Group centers from several binary images by their coordinates. Close centers form one group that corresponds to one blob, which is controlled by the minDistBetweenBlobs parameter. 4. From the groups, estimate final centers of blobs and their radiuses and return as locations and sizes of keypoints. This class performs several filtrations of returned blobs. You should set filterBy\* to true/false to turn on/off corresponding filtration. Available filtrations:
  - By color. This filter compares the intensity of a binary image at the center of a blob to blobColor. If they differ, the blob is filtered out. Use blobColor = 0 to extract dark blobs and blobColor = 255 to extract light blobs.
  - By area. Extracted blobs have an area between minArea (inclusive) and maxArea (exclusive).
  - By circularity. Extracted blobs have circularity (\(\frac{4*\pi*Area}{perimeter * perimeter}\)) between minCircularity (inclusive) and maxCircularity (exclusive).
  - By ratio of the minimum inertia to maximum inertia. Extracted blobs have this ratio between minInertiaRatio (inclusive) and maxInertiaRatio (exclusive).
  - By convexity. Extracted blobs have convexity (area / area of blob convex hull) between minConvexity (inclusive) and maxConvexity (exclusive).
  Default values of parameters are tuned to extract dark circular blobs.

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `SimpleBlobDetector​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static SimpleBlobDetector` | `__fromPtr__​(long addr)` |
    `static SimpleBlobDetector` | `create()` |
    `static SimpleBlobDetector` | `create​(SimpleBlobDetector_Params parameters)` |
    `protected void` | `finalize()` |
    `java.util.List<MatOfPoint>` | `getBlobContours()` |
    `java.lang.String` | `getDefaultName()` | Returns the algorithm string identifier.
    `SimpleBlobDetector_Params` | `getParams()` |
    `void` | `setParams​(SimpleBlobDetector_Params params)` |

    - ### Methods inherited from class org.opencv.features.Feature2D

      `compute, compute, defaultNorm, descriptorSize, descriptorType, detect, detect, detect, detect, detectAndCompute, detectAndCompute, empty, read, write`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SimpleBlobDetector

          protected SimpleBlobDetector​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static SimpleBlobDetector __fromPtr__​(long addr)

    - #### create

          public static SimpleBlobDetector create​(SimpleBlobDetector_Params parameters)

    - #### create

          public static SimpleBlobDetector create()

    - #### setParams

          public void setParams​(SimpleBlobDetector_Params params)

    - #### getParams

          public SimpleBlobDetector_Params getParams()

    - #### getDefaultName

          public java.lang.String getDefaultName()

      Description copied from class: `Algorithm`
      Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.
      Overrides:
        `getDefaultName` in class `Feature2D`
      Returns:
        automatically generated

    - #### getBlobContours

          public java.util.List<MatOfPoint> getBlobContours()

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Feature2D`
      Throws:
        `java.lang.Throwable`